RumahGagasan/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('blogs.urls')),
    path('authentication/', include('authentication.urls'))
] + static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

authentication/urls.py
from django.urls import path
from .views import auth_signup, auth_login, auth_logout

app_name = 'authentication'

urlpatterns = [
    path('signup/', auth_signup, name = 'authentication-signup'),
    path('login/', auth_login, name='authentication-login'),
    path('logout/', auth_logout, name='authentication-logout'),
]

blogs/urls.py
from django.urls import path
from .views import index, myBlog, createBlog, blogDetail, UpdateBlog, deleteBlog, createComment, likeBlog

app_name = 'blogs'

urlpatterns = [
    path('', index, name='blogs-index'),
    path('my-blog', myBlog, name='blogs-myBlog'),
    path('create-blog', createBlog, name='blogs-createBlog'),
    path('blog/<int:id>', blogDetail, name='blogs-blogDetail'),
    path('blog/update/<int:pk>', UpdateBlog.as_view(), name='blogs-updateBlog'),
    path('blog/delete/<int:id>', deleteBlog, name='blogs-deleteBlog'),
    path('blog/create-comment/<int:id>', createComment, name='blogs-createComment'),
    path('blog/like/<int:id>', likeBlog, name='blogs-likeBlog')
]

authentication/models.py
from django.db import models

# Create your models here.

blogs/models.py
from django.db import models
from django.contrib.auth.models import User
from django.urls import reverse

# Create your models here.
class Blog(models.Model):
    author = models.ForeignKey(User, on_delete=models.CASCADE)
    thumbnail = models.ImageField(upload_to='images', default = 'static/Blogs/images/no-image.jpg')
    base64_thumbnail = models.TextField(null=True)
    post_date = models.DateField(auto_now_add = True)
    title = models.CharField(max_length = 200, blank = False)
    body = models.TextField(max_length = 10000)
    likes = models.ManyToManyField(User, related_name='blog_for_like')
    
    def total_likes(self):
        return self.likes.count()

    def get_absolute_url(self):
        return reverse('blogs:blogs-index')


class Comment(models.Model):
    blog = models.ForeignKey(Blog, on_delete=models.CASCADE)
    comment = models.TextField()
    post_date = models.DateField(auto_now_add = True)

authentication/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User

class SignupForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']

blogs/forms.py
from django import forms
from .models import Blog, Comment

class BlogForm(forms.ModelForm):
    class Meta:
        model = Blog
        fields = ['title', 'body', 'thumbnail']
        widgets = {
            'title' : forms.TextInput(attrs = {'class': 'form-control'}),
            'body' : forms.Textarea(attrs = {'class': 'form-control'}),
            'thumbnail' : forms.FileInput(attrs = {'class': 'form-control'})
        }

class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ['comment']
        widgets = {
            'comment' : forms.TextInput(attrs = {'class': 'form-control'}),
        }

authentication/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.contrib import messages
from .forms import SignupForm

def auth_signup(request):
    if request.method == "POST":
        form = SignupForm(request.POST)
        if form.is_valid():
            form.save()
            username = form.cleaned_data.get("username")
            messages.success(request, 'Akun dengan username ' + username + " telah berhasil dibuat")
        else:
            messages.error(request, "Data input tidak valid")
        return redirect('authentication:authentication-signup')
    else:
        context = {'form' : SignupForm()}
        return render(request, "authentication/signupPage.html", context)

def auth_login(request):
    if request.method == "POST":
        username = request.POST.get('username')
        password = request.POST.get('password')
        user = authenticate(request, username = username, password = password)
        if user is not None:
            login(request, user)
            request.session['user_logged_username'] = username
            return redirect('blogs:blogs-index')
        else:
            messages.error(request, "Username atau password salah")
            return redirect('authentication:authentication-login')
    else:
        return render(request, "authentication/loginPage.html", context = {})

def auth_logout(request):
    logout(request)
    return redirect('blogs:blogs-index')

blogs/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.http import HttpResponseRedirect
from .models import Blog, Comment
from .forms import BlogForm, CommentForm
from django.contrib.auth.decorators import login_required
from django.views.generic import UpdateView
from django.utils.decorators import method_decorator

# Create your views here.
def index(request):
    context = {
        'blogs' : Blog.objects.all()
    }
    return render(request,"blogs/index.html", context)

@login_required(login_url='/authentication/login')
def myBlog(request):
    my_blogs = []
    for blog in Blog.objects.all():
        if request.user == blog.author:
            my_blogs.append(blog)
    context = {
        'my_blogs' : my_blogs
    }
    return render(request, "blogs/myBlog.html", context)

@login_required(login_url='/authentication/login')
def createBlog(request):
    import base64

    if request.method == "POST":
        blog_form = BlogForm(request.POST, request.FILES)
        if blog_form.is_valid():
            blog = blog_form.save(commit = False)
            blog.author = request.user
            with blog_form.cleaned_data["thumbnail"].open('rb') as file:
                blog.base64_thumbnail = "data:image/png;base64,{}".format(base64.b64encode(file.read()).decode())
                blog.save()
            return HttpResponseRedirect('/')
    
    context = {
        'blog_form' : BlogForm()
    }
    
    return render(request, 'blogs/createBlog.html', context)

def blogDetail(request, id):
    blog = get_object_or_404(Blog, pk = id)
    context = {
        'blog' : blog,
        'isAuthor' : (blog.author == request.user),
        'allComment' : Comment.objects.filter(blog = blog),
        'commentForm' : CommentForm()
    }
    return render(request, 'blogs/blogDetail.html', context)

@login_required(login_url='/authentication/login')
def deleteBlog(request, id):
    get_object_or_404(Blog, pk = id).delete()
    if request.path == '/myblogs/':
        return redirect('blogs:blogs-myBlogs')
    return redirect('blogs:blogs-index')

def createComment(request, id):
    if request.method == "POST":
        comment_data = CommentForm(request.POST or None)
        if comment_data.is_valid():
            blog = get_object_or_404(Blog, pk = id)
            comment_text = request.POST['comment']
            if(request.user): 
                comment = Comment.objects.create(blog = blog, comment = comment_text)
            else:
                comment = Comment.objects.create(blog = blog, comment = comment_text)
            comment.save()
    redirect_url = "/blog/" + str(id)
    return HttpResponseRedirect(redirect_url)

def likeBlog(request, id):
    blog = get_object_or_404(Blog, pk = id)
    if blog.likes.filter(id = request.user.id).exists():
        blog.likes.remove(request.user)
    else:
        blog.likes.add(request.user)
    return redirect('blogs:blogs-index')

@method_decorator(login_required, name='dispatch')
class UpdateBlog(UpdateView):
    model = Blog
    form_class = BlogForm
    template_name = 'blogs/updateBlog.html'

authentication/templates/authentication/loginPage.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'authentication/style.css' %}" />
{% endblock meta %}
{% block content %}
    <div class = "d-flex flex-column justify-content-center align-items-center padding-4">
        <p class = "montserrat-bold large-font margin-top-2">Log In</p>
        <form class = "full-size" action="" method="POST">
            {% csrf_token %}
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size montserrat-medium medium-font margin-1">
                    <p class = "margin-top-2">Username</p>
                    <input class = "full-size" type="text" name="username">
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size montserrat-medium medium-font margin-1">
                    <p class = "margin-top-2">Password</p>
                    <input class = "full-size" type="password" name="password">
                </div>
            </div>
            <button type="submit" value = "Submit" class="margin-top-2 btn btn-dark montserrat-semibold">Log In</button>
        </form>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                {% for message in messages %}
                    <p>{{ message }}</p>
                {% endfor %}
            </div>
        </div>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                <p>Belum memiliki akun?</p>
                <a href="{% url 'authentication:authentication-signup' %}">Sign Up</a>
            </div>
        </div>
    </div>
{% endblock content %}

authentication/templates/authentication/signupPage.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'authentication/style.css' %}" />
{% endblock meta %}
{% block content %}
    <div class = "d-flex flex-column justify-content-center align-items-center padding-4">
        <p class = "montserrat-bold large-font margin-top-2">Sign Up</p>
        <form class = "full-size" action="" method="POST">
            {% csrf_token %}
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Username</p>
                    {{ form.username }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Email</p>
                    {{ form.email }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Password</p>
                    {{ form.password1 }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Password confirmation</p>
                    {{ form.password2 }}
                </div>
            </div>
            <button type="submit" value = "Submit" class="margin-top-2 btn btn-dark montserrat-semibold">Sign Up</button>
        </form>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                {% for message in messages %}
                    <p>{{ message }}</p>
                {% endfor %}
            </div>
        </div>
        <div class = "full-size d-flex justify-content-center align-items-center">
            <div class = "full-size d-flex flex-column justify-content-center align-items-center montserrat-medium medium-font margin-1">
                <p>Sudah memiliki akun?</p>
                <a href="{% url 'authentication:authentication-login' %}">Login</a>
            </div>
        </div>
    </div>
{% endblock content %}

blogs/templates/blogs/blogDetail.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'blogs/style.css' %}" />
{% endblock meta %}

{% block content %}
    <div class = "full-size d-flex flex-column justify-content-center align-items-center" style = "padding: 4% 15%;">
        <div class="card margin-2 full-size">
            <img class="card-img-top" src="{{ blog.base64_thumbnail }}" alt="Card image cap">
            <div class="card-body">
                <div class = "full-size d-flex flex-row justify-content-between align-items-center">
                    <p class="card-title montserrat-bold large-font" style = "width: 80%;" >{{ blog.title }}</p>
                    {% if isAuthor %}
                    <div class = "d-flex flex-row justify-content-center align-items-center" style = "width: 20%;">
                        <a href="{% url 'blogs:blogs-updateBlog' blog.id %}" class="btn btn-secondary margin-1">Sunting</a>
                        <a href="{% url 'blogs:blogs-deleteBlog' blog.id %}" class="btn btn-danger margin-1">Hapus</a>
                    </div >
                    {% endif %}
                </div>
                <hr>
                <p class="card-text montserrat-regular medium-font margin-top-4">{{ blog.body }}</p>
            </div>
        </div>
        <div class="card margin-2 full-size">
            <form class = "full-size padding-2" method = "POST" action = "{% url 'blogs:blogs-createComment' blog.id %}">
                {% csrf_token %}
                {{ commentForm.as_p }}
                <button type="submit" class="btn btn-dark">Kirim</button>
            </form>
            {% if allComment %}
            <p class = "montserrat-semibold medium-font padding-top-2 padding-left-2">Komentar</p>
            <div class = "full-size d-flex flex-column justify-content-center align-items-center padding-1">
                {% for comment in allComment %}
                <div class="card comment margin-2 full-size">
                    <div class="card-body">
                        <hr>
                        <p class="card-text montserrat-regular medium-font">{{ comment.comment }}</p>
                    </div>
                </div>
                {% endfor %}
            </div>
            {% endif %}
        </div>
    </div>
{% endblock content %}

blogs/templates/blogs/createBlog.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'blogs/style.css' %}" />
{% endblock meta %}

{% block content %}
    <div class = "full-size d-flex flex-column justify-content-center align-items-center">
        <p class = "montserrat-bold large-font margin-top-4">Torehkan pemikiran</p>
        <form class = "d-flex flex-column justify-content-center align-items-center full-size padding-4" method = "POST" action = "{% url 'blogs:blogs-createBlog' %}" enctype="multipart/form-data">
            {% csrf_token %}
            <div class = "d-flex flex-column">
                <p class = "montserrat-regular medium-font">Judul</p>
                {{ blog_form.title }}
            </div>
            <div class = "d-flex flex-column margin-top-2">
                <p class = "montserrat-regular medium-font">Isi</p>
                {{ blog_form.body }}
            </div>
            <div class = "d-flex flex-row margin-top-4">
                <p class = "montserrat-regular medium-font">Thumbnail</p>
                {{ blog_form.thumbnail }}
            </div>
            <div id = "button" class = "d-flex justify-content-center align-items-center" style = "width: fit-content;">
                <button type="submit" class="btn btn-primary mt-3">Unggah</button>
            </div>
        </form>
    </div>
{% endblock content %}

blogs/templates/blogs/index.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'blogs/style.css' %}" />
{% endblock meta %}

{% block content %}
    <div class = "full-size d-flex flex-column justify-content-center align-items-center padding-4">
        <div class = "full-size d-flex flex-row justify-content-between align-items-center">
            <p id = "judul-index" class = "montserrat-bold large-font">Gagasan para penulis</p>
            <a href="{% url 'blogs:blogs-createBlog' %}" class="btn btn-warning montserrat-medium">Tulis gagasan baru ?</a>
        </div>
        {% if blogs %}
        <div class = "full-size d-flex flex-row justify-content-center align-items-center margin-top-4" style = "flex-wrap: wrap">
            {% for blog in blogs %}
            <div class="card margin-2" style = "width: 28%;">
                <img class="card-img-top" src="{{ blog.base64_thumbnail }}" alt="Card image cap">
                <div class="card-body">
                    <p class="card-title montserrat-semibold semi-large-font ">{{ blog.title }}</p>
                    <div class = "full-size d-flex flex-row justify-content-center align-items-center">
                        {% if request.user.is_authenticated %}
                            <form class = "d-flex flex-row justify-content-start align-items-center margin-right-4 full-size" style = "width: 100%" method = "POST" action = "{% url 'blogs:blogs-likeBlog' blog.id %}">
                                {% csrf_token %}
                                <button type="submit" class="btn btn-light" name = "{{ blog.id }}" value = "{{ blog.id }}">{{ blog.total_likes }} Suka</button>
                            </form>
                        {% endif %}
                        <a href="{% url 'blogs:blogs-blogDetail' blog.id %}" class="btn btn-dark montserrat-regular medium-font">
                            Detail
                        </a>
                    </div>
                </div>
            </div>
            {% endfor %}
        </div>
        {% endif %}
    </div>
{% endblock content %}

blogs/templates/blogs/myBlog.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'blogs/style.css' %}" />
{% endblock meta %}

{% block content %}
    <div class = "full-size d-flex flex-column justify-content-center align-items-center padding-4">
        <div class = "full-size d-flex flex-row justify-content-between align-items-center">
            <p id = "judul-index" class = "montserrat-bold large-font">Gagasan saya</p>
            <a href="{% url 'blogs:blogs-createBlog' %}" class="btn btn-warning montserrat-medium">Tulis gagasan baru ?</a>
        </div>
        {% if my_blogs %}
        <div class = "full-size d-flex flex-row justify-content-center align-items-center margin-top-4" style = "flex-wrap: wrap">
            {% for blog in my_blogs %}
            <div class="card margin-2" style = "width: 28%;">
                <img class="card-img-top" src="{{ blog.base64_thumbnail }}" alt="Card image cap">
                <div class="card-body">
                    <p class="card-title montserrat-semibold semi-large-font ">{{ blog.title }}</p>
                    {% if request.user.is_authenticated %}
                        <form class = "d-flex flex-row justify-content-start align-items-center full-size"method = "POST" action = "{% url 'blogs:blogs-likeBlog' blog.id %}">
                            {% csrf_token %}
                            <button type="submit" class="btn btn-light" name = "{{ blog.id }}" value = "{{ blog.id }}">{{ blog.total_likes }} Suka</button>
                        </form>
                    {% endif %}
                    <div class = "full-size d-flex flex-row justify-content-center align-items-center margin-top-4">
                        <a href="{% url 'blogs:blogs-blogDetail' blog.id %}" class="btn btn-dark montserrat-regular medium-font margin-1" style = "width: 30%">
                            Detail
                        </a>
                        <a href="{% url 'blogs:blogs-updateBlog' blog.id %}" class="btn btn-secondary montserrat-regular medium-font margin-1" style = "width: 35%">Sunting</a>
                        <a href="{% url 'blogs:blogs-deleteBlog' blog.id %}" class="btn btn-danger montserrat-regular medium-font margin-1" style = "width: 30%">Hapus</a>
                    </div>
                </div>
            </div>
            {% endfor %}
        </div>
        {% endif %}
    </div>
{% endblock content %}

blogs/templates/blogs/updateBlog.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'blogs/style.css' %}" />
{% endblock meta %}

{% block content %}
    <div class = "full-size d-flex flex-column justify-content-center align-items-center">
        <p class = "montserrat-bold large-font margin-top-4">Perbaharui gagasan</p>
        <form class = "full-size d-flex flex-column justify-content-center align-items-center padding-4" method = "POST" action = "{% url 'blogs:blogs-updateBlog' blog.id %}">
            {% csrf_token %}
            <div class = "full-size d-flex flex-column justify-content-center align-items-start">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Judul</p>
                    {{ form.title }}
                </div>
            </div>
            <div class = "full-size d-flex flex-column justify-content-center align-items-start">
                <div class = "full-size d-flex flex-column montserrat-regular medium-font margin-1">
                    <p class = "medium-font margin-top-2">Isi</p>
                    {{ form.body }}
                </div>
            </div>
            <button type="submit" class="btn btn-dark margin-top-2 montserrat-semibold">Perbaharui</button>
        </form>
    </div>
{% endblock content %}

templates/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <link rel="stylesheet" href="{% static 'style.css' %}">
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BmbxuPwQa2lc/FVzBcNJ7UAyJxM6wuqIj61tLrc4wSX0szH/Ev+nYRRuWlolflfl" crossorigin="anonymous">
        <link rel="icon" href="static/favicon.ico">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        {% block meta %}
        {% endblock meta %}
    </head>
    <body>
        <nav class="navbar navbar-expand-lg navbar-dark bg-dark">
            <a class="navbar-brand margin-left-2 montserrat-bold" href="{% url 'blogs:blogs-index' %}">Rumah Gagasan</a>
            <div class="collapse navbar-collapse full-size" id="navbarNavAltMarkup">
                <div class = "d-flex flex-row justify-content-start align-items-center padding-half" style = "width: 70%;">
                    <div class="navbar-nav">
                        <a class="nav-item nav-link montserrat-regular" href="{% url 'blogs:blogs-index' %}">Blog</a>
                    </div>
                    {% if request.user.is_authenticated %}
                        <div class="navbar-nav">
                            <a class="nav-item nav-link montserrat-regular" href="{% url 'blogs:blogs-myBlog' %}">Blog saya</a>
                        </div>
                    {% endif %}
                </div>
                <div class = "d-flex flex-row justify-content-end align-items-center padding-half" style = "width: 30%;">
                    <div class="navbar-nav">
                        {% if request.user.is_authenticated %}
                            <p class = "nav-item montserrat-regular margin-1" style = "color: white;">{{ request.session.user_logged_username }}</p>
                        {%  endif %}
                    </div>
                    <div class="navbar-nav">
                        {% if request.user.is_authenticated %}
                            <a class="nav-item nav-link montserrat-semibold" href="{% url 'authentication:authentication-logout' %}">Logout</a>
                        {% else %}
                            <a class="nav-item nav-link montserrat-regular" href="{% url 'authentication:authentication-login' %}">Login</a>
                        {%  endif %}
                    </div>
                </div>
            </div>
          </nav>
        {% block content %}
        {% endblock content %}
        <script src = "{% static 'jquery-3.5.1.min.js' %}"></script>

    </body>
</html>